# Methods
> The Methods should include a subsection on Implementation describing how the tool works and any relevant technical details required for implementation; and a subsection on Operation, which should include the minimal system requirements needed to run the software and an overview of the workflow. ...

> Methods sections should provide sufficient details of the materials and methods used so that the work can be repeated by others.

## Implementation
The TicTrainer server is written in JavaScript, using the Node.js runtime. JavaScript also runs locally on many of the TicTrainer webpages for form validation and AJAX requests.

Any page on the website that has information specific to a signed-in user is created dynamically by the server. These dynamic web pages are stored as .dynh files on the server. (".dynh" is a custom extension which stands for DYNamic Html.) These files have designated places for the server to inject the required unique fields (usually these include the user's ID and password) before sending the edited page back to the client.  Almost every page involved in a training session is stored and generated this way by the server.

During a session, the server mediates between the user and trainer via a session log file. When the trainer records a user's tic, the trainer's page sends a request (an XMLHttpRequest), asking the server to write a line to the log file. On the other side, the user's page continually checks the session log file on the server for changes, so it can reset the rewards when the user tics and end the session when the trainer leaves.

### Account registration & anonymity
The system is designed to ensure security of users' personally identifying information. To track the collective age of users and to allow potential individualized training dependent on age, the user is asked his or her birth month and year. However, the system saves only a randomly chosen birthdate within 45 days of the 15th day of the month reported.

An admin account can only be created by an existing admin. Admins can flag certain users as research participants and switch them to receive rewards differently from regular users. They can also view system and session log files.

### Storing data
Each user and trainer account has its own account data file on the server. This is a simple way to store the data without using some sort of SQL database. In addition, using one file per account should be faster and more efficient than using a couple large files with one entry per account. If many accounts were stored in the same file, then that file would need to be loaded and parsed through in its entirety every time account data is read or edited for any one of the users. The server would be doing extra work and it may delay any requests to edit account data made while someone else has the file open for editing their data.
